
REG_AX		equ	0	   ;   浪
REG_CX		equ	1
REG_DX		equ	2
REG_BX		equ	3
REG_SP		equ	4
REG_BP		equ	5
REG_SI		equ	6
REG_DI		equ	7


Wbit		EQU	00000001B  ;   
Dbit		EQU	00000010B  ;  
Mode		EQU	00001100B  ;   
JRQ		EQU	00010000B  ;   JMP REL8
PRQ		EQU	00100000B  ;   PUSH/POP
TRQ		EQU	01000000B  ;   Flags,AX
CRQ		EQU	10000000B  ;  CALL

;----------------- ࠢ騥  ------------------------
				     ; 7		     0
REG_USED	db	00010000b    ; DI SI BP SP BX DX CX AX

				     ; 7		   3  2     0
BT_FLAG 	db	00000000B    ; CRQ  TRQ  PRQ  JRQ  MODE  D  W


;   ,     ( CMP [BX],AL )

ARI_MASK	DB	10000111B    ;  CMP
		DB	11111111B    ;  

;  
;   :
;	  7    6   5   4 3   2	1  0
;	  TST  WPR 0   ROT   ADDBITS

TST		EQU	10000000B	; TEST REGISTER
WPR		EQU	01000000B	; Wbite PRESENT BIT
WPLACE		EQU	00100000B	; Wbite PLACE
ROT		EQU	00011000B	; ROTATE BY 0..3 BITES
ADDBITS 	EQU	00000111B	; ADDING 0...7 BITES (REG/COP)

TRASH_TAB	DB	10110000B,TST+WPR+WPLACE+7 ;MOV REG,IMM8/16
		DB	10010000B,TST+WPLACE+7	   ;XCHG AX,REG
		DB	01000000B,TST+WPLACE+7	   ;INC REG16
		DB	01001000B,TST+WPLACE+7	   ;DEC REG16

		DB	00000100B,01011111B ;WPR,ROT=3,ADDBITS=0...7
					    ;ADD,OR,ADC,... AL/AX,IMM8/16

		DB	00100111B,00011011B ;ROT=3,ADDBITS=0...3
					    ;DAA,DAS,AAA,AAS

		DB	11111000B,5	    ;STI,CLI,STD,CLD,STC,CLC
		DB	10011000B,0	    ;CBW
		DB	11010111B,0	    ;XLAT
		DB	11001100B,0	    ;INT 3
		DB	10011110B,1	    ;SAHF,LAHF
		DB	11110101B,0	    ;CMC
TR_TAB_END	EQU	$

JMP_ADDR	DW	0
CALL_ADDR	DW	0FFFFH

;----------------------------------------------------------------------------
RND		PROC	    ; DL = RND (0..DL)	 砩 

		PUSH	AX
		OR	DL,DL		     ; RND(0..0)=0
		JZ	EXRND
		PUSH	DX

		INC	DL		    ;  0FFh   +1
		JNZ	OKK
		DEC	DL
OKK:
		MOV	AX,0100H	    ; ࠧ 筮 १
		DIV	DL
		NOT	AH

		XCHG	AL,DL
		IN	AL,40H

		PUSH	CX
		XOR	AL,55H
OLD_RND 	EQU	$-1
		MOV	CL,AL
		IN	AL,40H
		RCL	AL,CL
		MOV	BYTE PTR CS:[OLD_RND],AL
		POP	CX

		CMP	AL,AH	  ; ᫨ RND , 祬 *࠭,
		JBE	OKK1	  ;  १  EO*࠭
		MOV	AL,AH
OKK1:
		XOR	AH,AH	      ;  祭 RND-  .१
		DIV	DL
		POP	DX
		MOV	DL,AL
EXRND:
		POP	AX
		RETN
RND		ENDP
;-------------------
TABTRASH	PROC

		PUSH	SI
		TEST	[BT_FLAG],TRQ	   ;TRASH REQUEST IS MASKED ?
		STC
		JNZ	TR_EXIT

		MOV	DL,(TR_TAB_END-TRASH_TAB)/2-1
		CALL	RND
		SHL	DL,1
		MOVZX	BX,DL
		MOV	SI,OFFSET TRASH_TAB

		MOV	AX,[SI+BX]

		MOV	DH,1		; AX , BX , ...

		TEST	AH,WPR		;   W ?
		JZ	ADDREG
		CALL	MAKE_W_BIT
		OR	[BT_FLAG],DL	; 
		MOV	DH,DL

		TEST	AH,WPLACE
		JZ	W_PLACE 	; W   
		SHL	DL,3		; W   
W_PLACE:
		OR	AL,DL
ADDREG:
		MOV	DL,AH
		AND	DL,ADDBITS    ; + RND    
		CALL	RND

		TEST	AH,TST		;   ?
		JZ	NO_TST

		CALL	TEST_USED
		JNZ	ADDREG
NO_TST:
		MOV	CL,AH
		AND	CL,ROT	    ;   
		SHR	CL,3

		SHL	DL,CL		  ; 
		OR	AL,DL

		STOSB

		TEST	AH,WPR
		JZ	NO_ADD_IMM
		TEST	DH,DH
		JZ	IMMED8
		IN	AL,40H
		STOSB
IMMED8:
		IN	AL,40H
		STOSB
NO_ADD_IMM:
		POP	SI
		AND	[BT_FLAG],NOT Wbit     ;  W
		CLC
TR_EXIT:	RET
TABTRASH	ENDP
;-------------------
MAKE_SUB	PROC

		TEST	[BT_FLAG],CRQ	  ;CALL REQUEST SET ?
		JNZ	ENDCALL

		MOV	AL,0EBH
		STOSB
		MOV	WORD PTR [JMP_CALL],DI
		INC	DI

;		 MOV	 DL,3		 ;TRASHLEN = RND (0...3)
;		 CALL	 TRASHCHAIN

		MOV	[CALL_ADDR],DI

		OR	[BT_FLAG],CRQ
		JMP	EXIT_CALL
ENDCALL:
		TEST	[BT_FLAG],JRQ
		JZ	SKIP_JMP
		CALL	JMP_TRASH	   ; JUMP
SKIP_JMP:
		TEST	[BT_FLAG],PRQ
		JZ	SKIP_STK
		CALL	STACK_TRASH	   ; PUSH/POP
SKIP_STK:
		CALL	TABTRASH
		MOV	AL,0C3H
		STOSB
		MOV	BX,0000H
JMP_CALL	EQU	$-2
		MOV	AX,DI
		SUB	AX,BX
		DEC	AL
		MOV	ES:[BX],AL
		AND	[BT_FLAG],NOT CRQ
EXIT_CALL:
		CLC
		RET
MAKE_SUB	ENDP
;-------------------
MAKE_CALL	PROC

		TEST	[BT_FLAG],CRQ
		JNZ	EXIT_CLL

		CMP	WORD PTR [CALL_ADDR],0FFFFH
		JE	EXIT_CLL

		MOV	BX,DI
		MOV	AL,0E8H
		STOSB
		MOV	AX,[CALL_ADDR]
		SUB	AX,DI
		SUB	AX,2
		STOSW
EXIT_CLL:
		RET
MAKE_CALL	ENDP
;-------------------
JMP_TRASH	PROC

; ଠ ᫮ 室 :
;
; 0111xxxx  -    樨 , ன  - ᬥ饭 Rel8
;     
;     0 - jo   2 - jb	4 - je	 6 - jbe  8 - js   A - jp   C - jl   E - jle
;     1 - jno  3 - jae	5 - jne  7 - ja   9 - jns  B - jnp  D - jge  F - jg


		test	[BT_FLAG],JRQ
		jnz	AddRel8 	 ;稬 Jump

		mov	al,01110000B	 ;Jxx Rel8

		mov	dl,0Fh
		call	RND

		or	al,dl	; Jump'a ⮢

		stosb			;࠭塞  楯窥
		mov	[JMP_ADDR],di	; Rel8

		inc	di
		or	[BT_FLAG],JRQ  ;⠭ Jump Request
		ret
AddRel8:
		mov	ax,di
		mov	bx,[JMP_ADDR]

		sub	ax,bx
		dec	al
		mov	es:[bx],al

		and	[BT_FLAG],not JRQ ;ᨬ   襭 Jmp'a
		ret

JMP_TRASH	ENDP
;-------------------
STACK_TRASH	PROC

		TEST	[BT_FLAG],JRQ	;    JMP'a ,
		STC			;  PUSH/POP 
		JNZ	EXIT_STK

		TEST	[BT_FLAG],CRQ	;    CALL'a ,
		STC			;  PUSH/POP 
		JNZ	EXIT_STK

		MOV	AL,01010000B
		TEST	[BT_FLAG],PRQ	; PUSH/POP REQUEST IS SET ?
		JNZ	INCSTACK

		MOV	DL,7
		CALL	RND
		OR	AL,DL
		STOSB
		OR    [BT_FLAG],PRQ
		RET
INCSTACK:
		OR	AL,00001000B	; POP REG
NXT_REG:
		MOV	DL,7		; 
		CALL	RND
		MOV	DH,1
		CALL	TEST_USED
		JNZ	NXT_REG
		OR	AL,DL
		STOSB
		AND    [BT_FLAG],NOT PRQ    ;   PUSH/POP
		CLC
EXIT_STK:
		RET
STACK_TRASH	ENDP
;-------------------
SHIFT_TRASH	PROC

;   SAL    CL

		CALL	MAKE_W_BIT	 ;   
		OR	[BT_FLAG],DL

		AND	[BT_FLAG],NOT Dbit   ;   

		MOV	AL,DL
		OR	AL,11000000B	 ; 

		MOV	DL,1
		PUSH	DX

		CALL	RND	 ;   CL  IMM8
		SHL	DL,1
		OR	AL,DL

		TEST	DL,DL
		POP	DX
		JNZ	SHIFT_CL
		CALL	RND
SHIFT_CL:
		SHL	DL,4	 ;   IMM8  1
		PUSHF
		OR	AL,DL

		STOSB

		OR	[BT_FLAG],Mode	;   
		CALL	MAKE_MODE_RM
		POPF
		JNZ	EXIT_SHIFT
		IN	AL,40H
		STOSB
EXIT_SHIFT:
		AND	[BT_FLAG],11110000B ; W,D,MODE  'a
		RET
SHIFT_TRASH	ENDP
;-------------------
ARI_IMMED_TRASH PROC

;    

		MOV	AL,10000000B	 ; 

		MOV	DL,1
		CALL	RND	 ;  S

		SHL	DL,1	 ; +  S
		TEST	DL,DL
		PUSHF		 ;   
		OR	AL,DL

		PUSH	AX
		CALL	MAKE_W_BIT	 ;   
		POP	AX

		OR	[BT_FLAG],DL	     ;  W 
		AND	[BT_FLAG],NOT Dbit   ;   

		OR	AL,DL

		STOSB

		OR	[BT_FLAG],Mode	;  
		CALL	MAKE_MODE_RM

		IN	AL,40H	   ; 
		STOSB

		POPF			   ;S=0 ?
		JNZ	EXIT_ARI
		TEST	[BT_FLAG],Wbit	   ;W=1 ?
		JZ	EXIT_ARI

		IN	AL,40H	   ; 
		STOSB
EXIT_ARI:
		AND	[BT_FLAG],11110000B ; W,D,MODE  'a
		RET
ARI_IMMED_TRASH ENDP
;-------------------
ARITHM_TRASH	PROC

;    

		CALL	MAKE_W_BIT

		MOV	AL,DL
		OR	[BT_FLAG],AL	;   W

		MOV	DL,7	;  
		CALL	RND

		MOV	BX,OFFSET ARI_MASK  ; 
		CALL	TYPE_CMD	    ;  
					    ;  
		PUSHF
		SHL	DL,3
		OR	AL,DL
		MOV	DL,1		 ;  D
		POPF
		JC	OP_SIZE_REG

		CALL	RND  ;  REG/MEM - REG
OP_SIZE_REG:
		SHL	DL,1		 ;  D
		OR	[BT_FLAG],DL	 ;    '
		OR	AL,DL

		STOSB		 ; 

		CALL	MAKE_MODE_RM

		AND	[BT_FLAG],11110000B ; W,D,MODE  'a
		RET
ARITHM_TRASH	ENDP
;-------------------
MAKE_W_BIT	PROC
;DL = Wbit
		PUSH	AX
		MOV	DL,Wbit 	; 
		MOV	DH,0FH

		MOV	AL,[REG_USED]	;    .
		AND	AL,DH		;  , W   = 1
		CMP	AL,DH
		JE	OP_SIZE16
		CALL	RND		;  W=0 - AL , W=1 - AX
OP_SIZE16:
		POP	AX
		RET
MAKE_W_BIT	ENDP
;-------------------
MAKE_MODE_RM	PROC
;    - MODE REG/MEM

		TEST	[BT_FLAG],Dbit	  ;  D=0 -   
		JNZ	TEST_REG	  ;   

		MOV	DL,7	       ;    
		CALL	RND	       ;   
		JMP	SECOND_BYTE
TEST_REG:
		MOV	DL,7
		CALL	RND	       ;  
		CALL	TEST_USED      ;    - ?
		JNZ	TEST_REG
SECOND_BYTE:
		XOR	AL,AL	 ;  

		SHL	DL,3	 ;  REG/
		OR	AL,DL

		MOV	BL,11000000B
		TEST	[BT_FLAG],Mode	; MODE   ?
		JNZ	OPERAND_REG	; 

		MOV	DL,3	  ;  MODE
		CALL	RND
		MOV	BL,DL
		ROR	BL,2
OPERAND_REG:
		MOV	DL,7	  ; REG/MEM
		CALL	RND

		CMP	BL,11000000B
		JNZ	MAKE_REGMEM
					 ;  
		TEST	[BT_FLAG],Dbit	 ;  D
		JNZ	MAKE_REGMEM

		MOV	DH,Wbit
		AND	DH,[BT_FLAG]
NXT_TST_REGMEM:
		CALL	TEST_USED
		JZ	MAKE_REGMEM
		MOV	DL,7	    ;   - 
		CALL	RND
		JMP	NXT_TST_REGMEM
MAKE_REGMEM:
		OR	AL,DL	 ; + REG/MEM
		OR	AL,BL	 ; + MODE
		STOSB
		PUSH	AX

		CMP	BL,00000000B	 ;  . 
		JNE	NXT_MODE
		CMP	DL,00000110B	 ;  MEM
		JE	INDEX16
NXT_MODE:
		CMP	BL,01000000B	 ; + IMM8
		JE	INDEX8
		CMP	BL,10000000B
		JNE	ARI_OUT
INDEX16:				 ; + IMM16
		IN	AL,40H
		STOSB
INDEX8:
		IN	AL,40H
		STOSB
ARI_OUT:
		POP	AX
		RET
MAKE_MODE_RM	ENDP
;-------------------
TEST_USED	PROC

; ZF=1 -  
;
; DL -  
; DH :
;      00 - 
;      01 - 

		PUSH	AX
		MOV	CL,DL
		TEST	DH,DH
		JZ	REG_SIZE8
REG_SIZE16:
		MOV	AH,1
		SHL	AH,CL
		TEST	[REG_USED],AH
		JMP	OK1
REG_SIZE8:
		MOV	AH,[REG_USED] ; ᪠ ᯮ㥬 ॣ஢
		MOV	AL,AH	      ; BhChBlCl
		AND	AL,0FH	      ; | | | |
		SHR	AH,4	      ; 76543210
		OR	AH,AL	      ;  | | | |
				      ;  DhAhDlAl
		MOV	AL,1
		SHL	AL,CL
		TEST	AH,AL
OK1:
		POP	AX
		RET
TEST_USED	ENDP
;-------------------
TYPE_CMD	PROC
;DL -   (0...7)
;BX -  

;0xxx0xxxb - ᪠ (xxx- )
;11111111b -  ᮪ ,  7  
		PUSH	 AX
NEXT_MASK:
		CMP	byte ptr [BX],0FFH
		STC
		JE	EXIT_CMD_1
		MOV	AL,[BX]
		MOV	AH,AL
		AND	AH,00000111B
		CMP	AH,DL
		JE	EXIT_CMD_0
		SHR	AL,4
		INC	BX
		CMP	AL,DL
		JNE	NEXT_MASK
EXIT_CMD_0:	CLC
EXIT_CMD_1:	POP	AX
		RET
TYPE_CMD	ENDP

